<template>
  <div>
    <CCard>
      <CCardHeader>
        <div>
          <font-awesome-icon :icon="['fas', 'th']" />
          <strong>Zone list</strong>
        </div>
        <div class="card-header-actions">
          <CButton
            type="submit"
            color="primary"
            :variant="'ghost'"
            @click="onShowDetail(0)"
          >
            <font-awesome-icon :icon="['fas', 'plus-circle']" class="width-1x" />
            Add Zone
          </CButton>
        </div>
      </CCardHeader>

      <CCardBody>
        <zone-search-form
          :default-condition="condition"
          :loading="loading"
          @submit="onSearch"
        />

        <zone-table
          :data="data"
          :loading="loading"
          @show-detail="onShowDetail"
          @delete="onConfirmDelete"
          @on-control="on"
          @off-control="off"
        />

        <app-pagination
          :total="total"
          :page-size="limit"
          :current-page="page"
          :align="`end`"
          :disabled="loading"
          @page-change="onPageChange"
        />
      </CCardBody>
    </CCard>

    <app-delete-confirm-dialog
      ref="deleteConfirmDialog"
      :name="'zone'"
      @confirm="onDelete"
    />

    <zone-detail-modal
      :id="selectedId"
      ref="zoneDetailModal"
      @modify="refresh"
    />
  </div>
</template>

<script>
import ZoneTable from '~/components/organisms/zones/ZoneTable'
import ZoneSearchForm from '~/components/organisms/zones/ZoneSearchForm'
import AppDeleteConfirmDialog from '~/components/molecules/AppDeleteConfirmDialog'
import AppPagination from '~/components/atoms/AppPagination'
import ZoneDetailModal from '~/components/organisms/zones/ZoneDetailModal'

import AsyncLoading from '~/mixins/do-async-loading'
import ConditionHandler from '~/mixins/condition'
import SearchFormHandler from '~/mixins/search-form'
import Paginator from '~/mixins/paginator'

export default {
  components: {
    ZoneTable,
    ZoneSearchForm,
    AppDeleteConfirmDialog,
    AppPagination,
    ZoneDetailModal
  },

  mixins: [
    AsyncLoading,
    ConditionHandler,
    SearchFormHandler,
    Paginator
  ],

  data: () => {
    return {
      data: [],
      total: 0,
      resourceTypeName: 'zone',
      selectedId: null,
      isOn: false
    }
  },

  mounted () {
    this.refresh()
  },

  methods: {
    /**
     * Call API get users by condition search
     * Show data on table result
     *
     * @return {Object} API response for error handle
     */
    async fetch () {
      const res = await this.$dam.getZoneList(this.query)

      if (Array.isArray(res.data) && res.data.length) {
        this.total = res.meta.total
        this.data = res.data
      }

      return res
    },

    /**
     * Open user detail modal
     *
     * @param {Number} id - Current zone
     */
    onShowDetail (id) {
      this.setSelectedId(id)
      this.$refs.zoneDetailModal.open()
    },

    /**
     * Open confirm delete
     * If confirm then call delete zone
     * Else cancel
     *
     * @param {String} id - Zone id
     */
    onConfirmDelete (id) {
      this.setSelectedId(id)
      this.$refs.deleteConfirmDialog.open()
    },

    /**
     * Call API delete.
     *
     * @param {String} selectedId - Zone id
     */
    async delete (selectedId) {
      await this.$dam.deleteZone({ id: selectedId })
    },

    /**
     * Set select id
     *
     * @param {Number} id - Zone id
     */
    setSelectedId (id) {
      this.selectedId = id
    },

    /**
     * Call API do on control zone
     *
     * @param {Number} selectedId - Zone item id
     */
    async on (selectedId) {
      await this.$dam.zoneOn({ id: selectedId })
      this.refresh()
    },

    /**
     * Call API do off control zone
     *
     * @param {Number} selectedId - Zone item id
     */
    async off (selectedId) {
      await this.$dam.zoneOff({ id: selectedId })
      this.refresh()
    }

  }
}
</script>
